"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.intersects = void 0;
/**
 * @packageDocumentation
 * @module array
 */
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const intersects_1 = require("../utils/intersects");
function intersects(input, inputModifier) {
    return (source) => input instanceof rxjs_1.Observable
        ? input.pipe(operators_1.switchMap((value) => source.pipe(operators_1.map(intersects_1.mapIntersection(value, inputModifier)))))
        : source.pipe(operators_1.map(intersects_1.mapIntersection(input, inputModifier)));
}
exports.intersects = intersects;
//# sourceMappingURL=intersects.js.map