"use strict";
/**
 * @packageDocumentation
 * @module array
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultSearch = exports.binarySearcher = void 0;
/**
 * Binary searcher method
 * @param searchValue
 * @param searchArray
 * @private
 * @internal
 */
function binarySearcher(searchValue, searchArray, property) {
    let first = 0; //left endpoint
    let last = searchArray.length - 1; //right endpoint
    let position = -1;
    let found = false;
    let middle;
    while (!found && first <= last) {
        middle = Math.floor((first + last) / 2);
        const checkValue = property ? searchArray[middle][property] : searchArray[middle];
        if (checkValue == searchValue) {
            found = true;
            position = middle;
        }
        else if (checkValue > searchValue) {
            //if in lower half
            last = middle - 1;
        }
        else {
            //in in upper half
            first = middle + 1;
        }
    }
    return position;
}
exports.binarySearcher = binarySearcher;
/**
 * @private
 * @param a
 * @param b
 */
function defaultSearch(a, b) {
    if (typeof a === 'string') {
        return a.localeCompare(b);
    }
    if (a === b)
        return 0;
    return a < b ? -1 : 1;
}
exports.defaultSearch = defaultSearch;
//# sourceMappingURL=binary-search.js.map