/**
 * @packageDocumentation
 * @module array
 */
import { InputModifierFn, PredicateFn } from '../types/array-compare';
/**
 * Filter an array to find intersecting items with optional predicate method, otherwise
 * uses simple comparison
 * @param input The input array of values to check against the source
 * @param predicate Optional method for comparison
 *
 * @returns Function that is used with RxJS map method
 * @private
 * @internal
 */
export declare function mapDifferenceWith<T>(input: T[], predicate?: PredicateFn<T>): (value: T[]) => T[];
/**
 *
 * @param checkArray
 * @param mutate
 */
export declare function mapDifference<T, K>(checkArray: T[], mutate?: InputModifierFn<T, T | K>): (value: T[]) => T[];
